/* 	$Archive: /General Utilities/CPUID/extcache.cpp $
	$Author : $
	$Date   : $
	$Header : $
	$History: extcache.cpp $
 * 
 * *****************  Version 5  *****************
 * User: Tanb         Date: 7/18/96    Time: 4:58p
 * Updated in $/General Utilities/CPUID
 * Minor changed in display
 */

#include "defines.h"
#include <iostream.h>
#include <iomanip.h>
#include <conio.h>

//cpu_cache_info() provides information about the instruction TLB,
//data TLB, L1 instruction cache and L1 data cache.

void cpuid::ext_cpu_cache_info(void)
{
  unsigned long reg_eax, reg_ebx, reg_ecx, reg_edx, test_reg; //Register variable
  unsigned long  bits7_0, bits15_8, bits23_16, bits31_24;    //TLB, data cache and
							     //L1 instruction cache information
							     //variable
  clrscr();
  cout << "Function 8000_0005 (EAX = 80000005)" << endl;
  cout << "==================================== " << "\n\n";
  cout << " Processor Cache Information : " << "\n\n";

  asm mov eax,0x80000005  //EAX = 8000_0005h 
  asm db 0x0F, 0xA2      //CPUID opcode
  reg_eax = _EAX;        //store the EAX register
  reg_ebx = _EBX;        //store data and instruction TLB
  reg_edx = _EDX;        //store the L1 data cache
  reg_ecx = _ECX;        //store the L1 instruction cache

  cout.setf(ios::uppercase);
  cout << " EAX == " << setw(8) << hex << reg_eax << "  EBX == "
		 << setw(8) << hex << reg_ebx << "  ECX == " << setw(8)
		 << hex << reg_ecx << "  EDX == " << setw(8) << hex
		 << reg_edx << "\n\n";
  
  test_reg = reg_ebx;                 //Data and instruction TLB
  bits7_0 = (test_reg & 0x000000ff);  //Instruction TLB entries
  test_reg = reg_ebx;
  bits15_8 = (test_reg & 0x0000ff00); //Assoiciativity of inst TLB
  bits15_8 >>= 8;
  test_reg = reg_ebx;
  bits23_16 = (test_reg & 0x00ff0000);//Data TLB entries
  bits23_16 >>= 16;
  test_reg = reg_ebx;
  bits31_24 = (test_reg & 0xff000000); //associativity of data TLB
  bits31_24 >>= 24;


  cout<<"\n\n";
  cout<<"       ------------------------------------------------------------ "
		<<endl;
  cout<<"       |        |         Data TLB        |  Instruction TLB       |"
		<< endl;
  cout<<"       ------------------------------------------------------------ "
		<< endl;             
  cout<<"       |        |Associativity| #Entries  |Associativity| #Entries |"
		<< endl;
  cout<<"       ------------------------------------------------------------ "
		<< endl;
  cout<<"       |        |Bits 31-24   |Bits 23-16 | Bits 15-8   | Bits 7-0 |"
		<< endl;
  cout<<"       ------------------------------------------------------------"
		<< endl;
  cout<<"       |  EBX   |     " << setw(2) << hex << bits31_24
		<<"      |    " << setw(2)<< hex << bits23_16 <<"     |      " << setw(2) << dec
		<< bits15_8 << "     |     " << setw(2) << hex << bits7_0 << "   |" << endl;
  cout<<"       ------------------------------------------------------------"
		<< endl;
  cout<<"       Note: " << endl;
  cout<<"            Full associativity is indicated by a value of 0FFh."
		<<"\n\n";
  cout<< "                       Press any key for more." <<"\n\n\n";
  getch();


  test_reg = reg_ecx;
  bits7_0 = (test_reg & 0x000000ff);  //Line size of L1 data cache
  test_reg = reg_ecx;
  bits15_8 = (test_reg & 0x0000ff00); //lines per tag of L1 data cache
  bits15_8 >>= 8;
  test_reg = reg_ecx;
  bits23_16 = (test_reg & 0x00ff0000);//assiciativity
  bits23_16 >>= 16;
  test_reg = reg_ecx;
  bits31_24 = (test_reg & 0xff000000);//Size 
  bits31_24 >>= 24;

  clrscr();
  cout<< "\n\n\n";
  cout<<"       ------------------------------------------------------------ "
		<<endl;
  cout<<"       |        |                L1    Data   Cache                |"
		<< endl;
  cout<<"       ------------------------------------------------------------ "
		<< endl;
  cout<<"       |        |    Size     |Associa -  | Lines  per  |Line Size |"
		<< endl;
  cout<<"       |        |  (Kbytes)   |tivity     |      Tag    |  (bytes) |"
		<< endl;
  cout<<"       ------------------------------------------------------------ "
		<< endl;
  cout<<"       |        |Bits 31-24   |Bits 23-16 | Bits 15-8   | Bits 7-0 |"
		<< endl;
  cout<<"       ------------------------------------------------------------"
		<< endl;
  cout<<"       |  ECX   |     " << setw(2) << hex << bits31_24
		<<"      |    " << setw(2)<< hex << bits23_16 <<"     |      " << setw(2) << dec
		<< bits15_8 << "     |     " << setw(2) << hex << bits7_0 << "   |" << endl;
  cout<<"       ------------------------------------------------------------"
		<< endl;

  cout<<"       Note: " << endl;
  cout<<"            Full associativity is indicated by a value of 0FFh."
		<<"\n\n";
  cout<< "                       Press any key for more." << endl;
  getch();

  test_reg = reg_edx;
  bits7_0 = (test_reg & 0x000000ff);  //line size of L1 inst cache
  test_reg = reg_edx;
  bits15_8 = (test_reg & 0x0000ff00); //lines per tag of L1 inst cahce
  bits15_8 >>= 8;
  test_reg = reg_edx;
  bits23_16 = (test_reg & 0x00ff0000);//associativity 
  bits23_16 >>= 16;
  test_reg = reg_edx;
  bits31_24 = (test_reg & 0xff000000);//size  
  bits31_24 >>= 24;

  clrscr();
  cout<< "\n\n";
  cout<<"       ------------------------------------------------------------ "
		<<endl;
  cout<<"       |        |            L1 Instruction Cache                  |"
		<< endl;
  cout<<"       ------------------------------------------------------------ "
		<< endl;
  cout<<"       |        |    Size     |Associa -  | Lines  per  |Line Size |"
		<< endl;
  cout<<"       |        |  (Kbytes)   |tivity     |      Tag    |  (bytes) |"
		<< endl;
  cout<<"       ------------------------------------------------------------ "
		<< endl;
  cout<<"       |        |Bits 31-24   |Bits 23-16 | Bits 15-8   | Bits 7-0 |"
		<< endl;
  cout<<"       ------------------------------------------------------------"
		<< endl;
  cout<<"       |  EDX   |     " << setw(2) << hex << bits31_24
		<<"      |    " << setw(2)<< hex << bits23_16 <<"     |      " << setw(2) << dec
		<< bits15_8 << "     |     " << setw(2) << hex << bits7_0 << "   |" << endl;
  cout<<"       ------------------------------------------------------------"
		<< endl;
  cout<<"       Note: " << endl;
  cout<<"            Full associativity is indicated by a value of 0FFh."
		<<endl;
  cout<<"\n\n";
  cout.unsetf(ios::uppercase);
}
